#!/usr/bin/python

import Image, ImageDraw

radius    = 8
bgcolor   = "Black"
nodecolor = "White"
linecolor = "White"
txtcolor  = "Black"

imgsize = (640, 640)

def build_image(nodeposs, arcs):

    img = Image.new("RGB", imgsize, bgcolor)
    draw = ImageDraw.Draw(img)

    for a,b in arcs:
        draw.line((nodeposs[a], nodeposs[b]), width=1, fill=linecolor)

    for i,(x,y) in enumerate(nodeposs):
        draw.ellipse(((x-radius, y-radius), (x+radius, y+radius)), fill=nodecolor)
        txt = str(i)
        tw,th = draw.textsize(txt)
        draw.text((x-tw/2+1, y-th/2),txt, fill=txtcolor)
    return img

if __name__ == '__main__':
    import sys

    if len(sys.argv) != 4:
        sys.exit("Usage: gravi.py nodeposfile arcfile pngfile")
        
    nodeposs = [tuple(map(int, l.split())) for l in file(sys.argv[1])]
    arcf     = file(sys.argv[2])
    nof_vars = int(arcf.readline())
    arcs     = [tuple(map(int, l.split())) for l in arcf.xreadlines()]

    img = build_image(nodeposs, arcs)
    img.save(sys.argv[3],"PNG")
